--- old/usr/src/uts/i86pc/vm/hat_i86.c	2015-11-25 13:59:42.023347595 -0500
+++ new/usr/src/uts/i86pc/vm/hat_i86.c	2015-11-25 13:59:42.027112668 -0500
@@ -260,7 +260,7 @@
 	if (can_steal_post_boot == 0)
 		can_steal_post_boot = 1;
 
-	ASSERT(AS_WRITE_HELD(as, &as->a_lock));
+	ASSERT(AS_WRITE_HELD(as));
 	hat = kmem_cache_alloc(hat_cache, KM_SLEEP);
 	hat->hat_as = as;
 	mutex_init(&hat->hat_mutex, NULL, MUTEX_DEFAULT, NULL);
@@ -393,7 +393,7 @@
 void
 hat_free_start(hat_t *hat)
 {
-	ASSERT(AS_WRITE_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(AS_WRITE_HELD(hat->hat_as));
 
 	/*
 	 * If the hat is currently a stealing victim, wait for the stealing
@@ -726,12 +726,12 @@
 	/*
 	 * Set up the kernel's hat
 	 */
-	AS_LOCK_ENTER(&kas, &kas.a_lock, RW_WRITER);
+	AS_LOCK_ENTER(&kas, RW_WRITER);
 	kas.a_hat = kmem_cache_alloc(hat_cache, KM_NOSLEEP);
 	mutex_init(&kas.a_hat->hat_mutex, NULL, MUTEX_DEFAULT, NULL);
 	kas.a_hat->hat_as = &kas;
 	kas.a_hat->hat_flags = 0;
-	AS_LOCK_EXIT(&kas, &kas.a_lock);
+	AS_LOCK_EXIT(&kas);
 
 	CPUSET_ZERO(khat_cpuset);
 	CPUSET_ADD(khat_cpuset, CPU->cpu_id);
@@ -1157,7 +1157,7 @@
 	 */
 	ASSERT(IS_PAGEALIGNED(vaddr));
 	ASSERT(IS_PAGEALIGNED(eaddr));
-	ASSERT(AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(AS_LOCK_HELD(hat->hat_as));
 	if ((uintptr_t)hat->hat_as->a_userlimit < eaddr)
 		eaddr = (uintptr_t)hat->hat_as->a_userlimit;
 
@@ -1438,8 +1438,7 @@
 	++curthread->t_hatdepth;
 	ASSERT(curthread->t_hatdepth < 16);
 
-	ASSERT(hat == kas.a_hat ||
-	    AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(hat == kas.a_hat || AS_LOCK_HELD(hat->hat_as));
 
 	if (flags & HAT_LOAD_SHARE)
 		hat->hat_flags |= HAT_SHARED;
@@ -1587,8 +1586,7 @@
 	XPV_DISALLOW_MIGRATE();
 	ASSERT(IS_PAGEALIGNED(va));
 	ASSERT(hat == kas.a_hat || va < _userlimit);
-	ASSERT(hat == kas.a_hat ||
-	    AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(hat == kas.a_hat || AS_LOCK_HELD(hat->hat_as));
 	ASSERT((flags & supported_memload_flags) == flags);
 
 	ASSERT(!IN_VA_HOLE(va));
@@ -1645,8 +1643,7 @@
 	XPV_DISALLOW_MIGRATE();
 	ASSERT(IS_PAGEALIGNED(va));
 	ASSERT(hat == kas.a_hat || va + len <= _userlimit);
-	ASSERT(hat == kas.a_hat ||
-	    AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(hat == kas.a_hat || AS_LOCK_HELD(hat->hat_as));
 	ASSERT((flags & supported_memload_flags) == flags);
 
 	/*
@@ -1781,8 +1778,7 @@
 	XPV_DISALLOW_MIGRATE();
 	ASSERT(IS_PAGEALIGNED(va));
 	ASSERT(hat == kas.a_hat || eva <= _userlimit);
-	ASSERT(hat == kas.a_hat ||
-	    AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(hat == kas.a_hat || AS_LOCK_HELD(hat->hat_as));
 	ASSERT((flags & supported_devload_flags) == flags);
 
 	/*
@@ -1890,7 +1886,7 @@
 		panic("hat_unlock() address out of range - above _userlimit");
 
 	XPV_DISALLOW_MIGRATE();
-	ASSERT(AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(AS_LOCK_HELD(hat->hat_as));
 	while (vaddr < eaddr) {
 		(void) htable_walk(hat, &ht, &vaddr, eaddr);
 		if (ht == NULL)
@@ -2645,8 +2641,7 @@
 	XPV_DISALLOW_MIGRATE();
 	ASSERT(IS_PAGEALIGNED(vaddr));
 	ASSERT(IS_PAGEALIGNED(eaddr));
-	ASSERT(hat == kas.a_hat ||
-	    AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(hat == kas.a_hat || AS_LOCK_HELD(hat->hat_as));
 	for (; vaddr < eaddr; vaddr += LEVEL_SIZE(ht->ht_level)) {
 try_again:
 		oldpte = htable_walk(hat, &ht, &vaddr, eaddr);
@@ -2856,8 +2851,7 @@
 	pgcnt_t		pg_off;
 
 	ASSERT(hat == kas.a_hat || vaddr <= _userlimit);
-	ASSERT(hat == kas.a_hat ||
-	    AS_LOCK_HELD(hat->hat_as, &hat->hat_as->a_lock));
+	ASSERT(hat == kas.a_hat || AS_LOCK_HELD(hat->hat_as));
 	if (IN_VA_HOLE(vaddr))
 		return (0);
 
--- old/usr/src/uts/i86xpv/io/privcmd.c	2015-11-25 13:59:42.233591454 -0500
+++ new/usr/src/uts/i86xpv/io/privcmd.c	2015-11-25 13:59:42.237201153 -0500
@@ -169,14 +169,14 @@
 		 * Find the segment we want to mess with, then add
 		 * the mfn range to the segment.
 		 */
-		AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
+		AS_LOCK_ENTER(as, RW_READER);
 		if ((seg = as_findseg(as, addr, 0)) == NULL ||
 		    addr + mmu_ptob(mme->npages) > seg->s_base + seg->s_size)
 			error = EINVAL;
 		else
 			error = segmf_add_mfns(seg, addr,
 			    mme->mfn, mme->npages, mmc->dom);
-		AS_LOCK_EXIT(as, &as->a_lock);
+		AS_LOCK_EXIT(as);
 
 		if (error != 0)
 			break;
@@ -219,7 +219,7 @@
 	    caddr_t, mmb->addr);
 
 	addr = (caddr_t)mmb->addr;
-	AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
+	AS_LOCK_ENTER(as, RW_READER);
 	if ((seg = as_findseg(as, addr, 0)) == NULL ||
 	    addr + ptob(mmb->num) > seg->s_base + seg->s_size) {
 		error = EINVAL;
@@ -260,7 +260,7 @@
 	}
 
 done:
-	AS_LOCK_EXIT(as, &as->a_lock);
+	AS_LOCK_EXIT(as);
 
 	DTRACE_XPV3(mmapbatch__end, int, error, struct seg *, seg, caddr_t,
 	    mmb->addr);
--- old/usr/src/uts/sfmmu/vm/hat_sfmmu.c	2015-11-25 13:59:42.355478443 -0500
+++ new/usr/src/uts/sfmmu/vm/hat_sfmmu.c	2015-11-25 13:59:42.359778407 -0500
@@ -1318,9 +1318,9 @@
 	/*
 	 * We grab the first hat for the kernel,
 	 */
-	AS_LOCK_ENTER(&kas, &kas.a_lock, RW_WRITER);
+	AS_LOCK_ENTER(&kas, RW_WRITER);
 	kas.a_hat = hat_alloc(&kas);
-	AS_LOCK_EXIT(&kas, &kas.a_lock);
+	AS_LOCK_EXIT(&kas);
 
 	/*
 	 * Initialize hblk_reserve.
@@ -1463,7 +1463,7 @@
 	uint64_t cnum;
 	extern uint_t get_color_start(struct as *);
 
-	ASSERT(AS_WRITE_HELD(as, &as->a_lock));
+	ASSERT(AS_WRITE_HELD(as));
 	sfmmup = kmem_cache_alloc(sfmmuid_cache, KM_SLEEP);
 	sfmmup->sfmmu_as = as;
 	sfmmup->sfmmu_flags = 0;
@@ -1917,7 +1917,7 @@
 void
 hat_free_start(struct hat *sfmmup)
 {
-	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as));
 	ASSERT(sfmmup != ksfmmup);
 	ASSERT(sfmmup->sfmmu_xhat_provider == NULL);
 
@@ -2247,8 +2247,7 @@
 		return;
 	}
 
-	ASSERT((hat == ksfmmup) ||
-	    AS_LOCK_HELD(hat->sfmmu_as, &hat->sfmmu_as->a_lock));
+	ASSERT((hat == ksfmmup) || AS_LOCK_HELD(hat->sfmmu_as));
 
 	if (flags & ~SFMMU_LOAD_ALLFLAG)
 		cmn_err(CE_NOTE, "hat_memload: unsupported flags %d",
@@ -2303,8 +2302,7 @@
 
 	ASSERT(!(flags & ~SFMMU_LOAD_ALLFLAG));
 	ASSERT(!(attr & ~SFMMU_LOAD_ALLATTR));
-	ASSERT((hat == ksfmmup) ||
-	    AS_LOCK_HELD(hat->sfmmu_as, &hat->sfmmu_as->a_lock));
+	ASSERT((hat == ksfmmup) || AS_LOCK_HELD(hat->sfmmu_as));
 	if (len == 0)
 		panic("hat_devload: zero len");
 	if (flags & ~SFMMU_LOAD_ALLFLAG)
@@ -3973,8 +3971,7 @@
 	ASSERT(sfmmup != NULL);
 	ASSERT(sfmmup->sfmmu_xhat_provider == NULL);
 
-	ASSERT((sfmmup == ksfmmup) ||
-	    AS_LOCK_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT((sfmmup == ksfmmup) || AS_LOCK_HELD(sfmmup->sfmmu_as));
 	ASSERT((len & MMU_PAGEOFFSET) == 0);
 	endaddr = addr + len;
 	hblktag.htag_id = sfmmup;
@@ -4770,8 +4767,7 @@
 	ASSERT(sfmmup != NULL);
 	ASSERT(sfmmup->sfmmu_xhat_provider == NULL);
 
-	ASSERT((sfmmup == ksfmmup) ||
-	    AS_LOCK_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT((sfmmup == ksfmmup) || AS_LOCK_HELD(sfmmup->sfmmu_as));
 
 	if (sfmmup == ksfmmup) {
 		while ((pfn = sfmmu_vatopfn(addr, sfmmup, &tte))
@@ -4920,8 +4916,7 @@
 
 	CPUSET_ZERO(cpuset);
 
-	ASSERT((sfmmup == ksfmmup) ||
-	    AS_LOCK_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT((sfmmup == ksfmmup) || AS_LOCK_HELD(sfmmup->sfmmu_as));
 	ASSERT((len & MMU_PAGEOFFSET) == 0);
 	ASSERT(((uintptr_t)addr & MMU_PAGEOFFSET) == 0);
 
@@ -5714,7 +5709,7 @@
 	}
 
 	ASSERT((sfmmup == ksfmmup) || (flags & HAT_UNLOAD_OTHER) || \
-	    AS_LOCK_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	    AS_LOCK_HELD(sfmmup->sfmmu_as));
 
 	ASSERT(sfmmup != NULL);
 	ASSERT((len & MMU_PAGEOFFSET) == 0);
@@ -6332,8 +6327,7 @@
 	cpuset_t cpuset;
 
 	ASSERT(sfmmup->sfmmu_xhat_provider == NULL);
-	ASSERT((sfmmup == ksfmmup) ||
-	    AS_LOCK_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT((sfmmup == ksfmmup) || AS_LOCK_HELD(sfmmup->sfmmu_as));
 	ASSERT((len & MMU_PAGEOFFSET) == 0);
 	ASSERT((clearflag == HAT_SYNC_DONTZERO) ||
 	    (clearflag == HAT_SYNC_ZERORM));
@@ -7976,7 +7970,7 @@
 
 	/*
 	 * We would like to
-	 * ASSERT(AS_LOCK_HELD(as, &as->a_lock));
+	 * ASSERT(AS_LOCK_HELD(as));
 	 * but we can't because the iommu driver will call this
 	 * routine at interrupt time and it can't grab the as lock
 	 * or it will deadlock: A thread could have the as lock
@@ -14031,7 +14025,7 @@
 
 	ASSERT(sfmmup->sfmmu_xhat_provider == NULL);
 	ASSERT(sfmmup != ksfmmup);
-	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as));
 	ASSERT(srdp->srd_refcnt > 0);
 	ASSERT(!(flags & ~HAT_REGION_TYPE_MASK));
 	ASSERT(flags == HAT_REGION_TEXT || flags == HAT_REGION_ISM);
@@ -14334,7 +14328,7 @@
 	ASSERT(rgnp->rgn_id == rid);
 	ASSERT((rgnp->rgn_flags & SFMMU_REGION_TYPE_MASK) == r_type);
 	ASSERT(!(rgnp->rgn_flags & SFMMU_REGION_FREE));
-	ASSERT(AS_LOCK_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT(AS_LOCK_HELD(sfmmup->sfmmu_as));
 
 	ASSERT(sfmmup->sfmmu_xhat_provider == NULL);
 	if (r_type == SFMMU_REGION_HME && sfmmup->sfmmu_as->a_xhat != NULL) {
@@ -15130,7 +15124,7 @@
 	ASSERT(srdp != NULL);
 	ASSERT(scdp != NULL);
 	ASSERT(scdp->scd_refcnt > 0);
-	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as));
 
 	if ((old_scdp = sfmmup->sfmmu_scdp) != NULL) {
 		ASSERT(old_scdp != scdp);
@@ -15242,7 +15236,7 @@
 	int ret;
 
 	ASSERT(srdp != NULL);
-	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT(AS_WRITE_HELD(sfmmup->sfmmu_as));
 
 	mutex_enter(&srdp->srd_scd_mutex);
 	for (scdp = srdp->srd_scdp; scdp != NULL;
@@ -15348,7 +15342,7 @@
 	ASSERT(scdp->scd_refcnt);
 	ASSERT(!sfmmup->sfmmu_free);
 	ASSERT(sfmmu_hat_lock_held(sfmmup));
-	ASSERT(AS_LOCK_HELD(sfmmup->sfmmu_as, &sfmmup->sfmmu_as->a_lock));
+	ASSERT(AS_LOCK_HELD(sfmmup->sfmmu_as));
 
 	/*
 	 * Wait for ISM maps to be updated.
--- old/usr/src/uts/sparc/v9/os/simulator.c	2015-11-25 13:59:42.838979614 -0500
+++ new/usr/src/uts/sparc/v9/os/simulator.c	2015-11-25 13:59:42.842918341 -0500
@@ -1087,7 +1087,7 @@
 
 	as = p->p_as;
 
-	AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
+	AS_LOCK_ENTER(as, RW_READER);
 	mapseg = as_findseg(as, (caddr_t)rp->r_pc, 0);
 	ASSERT(mapseg != NULL);
 	svd = (struct segvn_data *)mapseg->s_data;
@@ -1098,11 +1098,11 @@
 	SEGVN_LOCK_ENTER(as, &svd->lock, RW_READER);
 	if ((svd->type & MAP_TYPE) & MAP_SHARED) {
 		SEGVN_LOCK_EXIT(as, &svd->lock);
-		AS_LOCK_EXIT(as, &as->a_lock);
+		AS_LOCK_EXIT(as);
 		return (SIMU_ILLEGAL);
 	}
 	SEGVN_LOCK_EXIT(as, &svd->lock);
-	AS_LOCK_EXIT(as, &as->a_lock);
+	AS_LOCK_EXIT(as);
 
 	/*
 	 * A "flush" instruction using the user PC's vaddr will not work
@@ -1114,9 +1114,9 @@
 	    F_SOFTLOCK, S_READ))
 		return (SIMU_FAULT);
 
-	AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
+	AS_LOCK_ENTER(as, RW_READER);
 	pfnum = hat_getpfnum(as->a_hat, (caddr_t)rp->r_pc);
-	AS_LOCK_EXIT(as, &as->a_lock);
+	AS_LOCK_EXIT(as);
 	if (pf_is_memory(pfnum)) {
 		pp = page_numtopp_nolock(pfnum);
 		ASSERT(pp == NULL || PAGE_LOCKED(pp));
@@ -1126,12 +1126,12 @@
 		return (SIMU_FAULT);
 	}
 
-	AS_LOCK_ENTER(as, &as->a_lock, RW_READER);
+	AS_LOCK_ENTER(as, RW_READER);
 	ka = ppmapin(pp, PROT_READ|PROT_WRITE, (caddr_t)rp->r_pc);
 	*(uint_t *)(ka + (uintptr_t)(rp->r_pc % PAGESIZE)) = inst;
 	doflush(ka + (uintptr_t)(rp->r_pc % PAGESIZE));
 	ppmapout(ka);
-	AS_LOCK_EXIT(as, &as->a_lock);
+	AS_LOCK_EXIT(as);
 
 	(void) as_fault(as->a_hat, as, (caddr_t)(rp->r_pc & PAGEMASK),
 	    PAGESIZE, F_SOFTUNLOCK, S_READ);
--- old/usr/src/uts/sparc/v9/vm/seg_nf.c	2015-11-25 13:59:42.983436381 -0500
+++ new/usr/src/uts/sparc/v9/vm/seg_nf.c	2015-11-25 13:59:42.987002674 -0500
@@ -188,7 +188,7 @@
 	size_t size;
 	struct as *as = seg->s_as;
 
-	ASSERT(as && AS_WRITE_HELD(as, &as->a_lock));
+	ASSERT(as && AS_WRITE_HELD(as));
 
 	/*
 	 * Need a page per virtual color or just 1 if no vac.
@@ -306,7 +306,7 @@
 static int
 segnf_unmap(struct seg *seg, caddr_t addr, size_t len)
 {
-	ASSERT(seg->s_as && AS_WRITE_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_WRITE_HELD(seg->s_as));
 
 	/*
 	 * Check for bad sizes.
@@ -375,7 +375,7 @@
 static void
 segnf_free(struct seg *seg)
 {
-	ASSERT(seg->s_as && AS_WRITE_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_WRITE_HELD(seg->s_as));
 }
 
 /*
@@ -391,7 +391,7 @@
 static int
 segnf_setprot(struct seg *seg, caddr_t addr, size_t len, uint_t prot)
 {
-	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as));
 	return (EACCES);
 }
 
@@ -400,7 +400,7 @@
 segnf_checkprot(struct seg *seg, caddr_t addr, size_t len, uint_t prot)
 {
 	uint_t sprot;
-	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as));
 
 	sprot = seg->s_as == &kas ?  PROT_READ : PROT_READ|PROT_USER;
 	return ((prot & sprot) == prot ? 0 : EACCES);
@@ -424,7 +424,7 @@
 {
 	size_t pgno = seg_page(seg, addr + len) - seg_page(seg, addr) + 1;
 	size_t p;
-	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as));
 
 	for (p = 0; p < pgno; ++p)
 		protv[p] = PROT_READ;
@@ -435,7 +435,7 @@
 static u_offset_t
 segnf_getoffset(struct seg *seg, caddr_t addr)
 {
-	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as));
 
 	return ((u_offset_t)0);
 }
@@ -444,7 +444,7 @@
 static int
 segnf_gettype(struct seg *seg, caddr_t addr)
 {
-	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as));
 
 	return (MAP_SHARED);
 }
@@ -453,7 +453,7 @@
 static int
 segnf_getvp(struct seg *seg, caddr_t addr, struct vnode **vpp)
 {
-	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as, &seg->s_as->a_lock));
+	ASSERT(seg->s_as && AS_LOCK_HELD(seg->s_as));
 
 	*vpp = &nfvp;
 	return (0);
--- old/usr/src/uts/sun4/io/rootnex.c	2015-11-25 13:59:43.105759034 -0500
+++ new/usr/src/uts/sun4/io/rootnex.c	2015-11-25 13:59:43.109484477 -0500
@@ -746,7 +746,7 @@
 			 * the hat of the system MMU.  At alternative
 			 * would be to panic .. this might well be better ..
 			 */
-			ASSERT(AS_READ_HELD(seg->s_as, &seg->s_as->a_lock));
+			ASSERT(AS_READ_HELD(seg->s_as));
 			hat = seg->s_as->a_hat;
 			cmn_err(CE_NOTE, "rootnex_map_fault: nil hat");
 		}
